## GActionGroup

GActionGroup — A group of actions

## Functions

gchar ** | g_action_group_list_actions ()
gboolean | g_action_group_query_action ()
gboolean | g_action_group_has_action ()
gboolean | g_action_group_get_action_enabled ()
const GVariantType * | g_action_group_get_action_parameter_type ()
const GVariantType * | g_action_group_get_action_state_type ()
GVariant * | g_action_group_get_action_state_hint ()
GVariant * | g_action_group_get_action_state ()
void | g_action_group_change_action_state ()
void | g_action_group_activate_action ()
void | g_action_group_action_added ()
void | g_action_group_action_removed ()
void | g_action_group_action_enabled_changed ()
void | g_action_group_action_state_changed ()

## Signals

void | action-added | Has Details
void | action-enabled-changed | Has Details
void | action-removed | Has Details
void | action-state-changed | Has Details

## Types and Values

| GActionGroup
struct | GActionGroupInterface

## Object Hierarchy

        GInterface
        ╰── GActionGroup

## Prerequisites

GActionGroup requires GObject.

## Known Derived Interfaces

GActionGroup is required by GRemoteActionGroup.

## Known Implementations

GActionGroup is implemented by GApplication, GDBusActionGroup and GSimpleActionGroup.

## Includes

    #include <gio/gio.h>

## Description

GActionGroup represents a group of actions. Actions can be used to expose functionality in a structured way, either from one part of a program to another, or to the outside world. Action groups are often used together with a GMenuModel that provides additional representation data for displaying the actions to the user, e.g. in a menu.

The main way to interact with the actions in a GActionGroup is to activate them with `g_action_group_activate_action()`. Activating an action may require a GVariant parameter. The required type of the parameter can be inquired with `g_action_group_get_action_parameter_type()`. Actions may be disabled, see `g_action_group_get_action_enabled()`. Activating a disabled action has no effect.

Actions may optionally have a state in the form of a GVariant. The current state of an action can be inquired with `g_action_group_get_action_state()`. Activating a stateful action may change its state, but it is also possible to set the state by calling `g_action_group_change_action_state()`.

As typical example, consider a text editing application which has an option to change the current font to 'bold'. A good way to represent this would be a stateful action, with a boolean state. Activating the action would toggle the state.

Each action in the group has a unique name (which is a string). All method calls, except `g_action_group_list_actions()` take the name of an action as an argument.

The GActionGroup API is meant to be the 'public' API to the action group. The calls here are exactly the interaction that 'external forces' (eg: UI, incoming D-Bus messages, etc.) are supposed to have with actions. 'Internal' APIs (ie: ones meant only to be accessed by the action group implementation) are found on subclasses. This is why you will find - for example - `g_action_group_get_action_enabled()` but not an equivalent `set()` call.

Signals are emitted on the action group in response to state changes on individual actions.

Implementations of GActionGroup should provide implementations for the virtual functions `g_action_group_list_actions()` and `g_action_group_query_action()`. The other virtual functions should not be implemented - their "wrappers" are actually implemented with calls to `g_action_group_query_action()`.

## Functions

### g_action_group_list_actions ()

    gchar **
    g_action_group_list_actions (GActionGroup *action_group);

Lists the actions contained within `action_group` .

The caller is responsible for freeing the list with `g_strfreev()` when it is no longer required.

#### Parameters

action_group | a GActionGroup |

#### Returns

a `NULL`-terminated array of the names of the actions in the group.

[transfer full]

Since: 2.28

### g_action_group_query_action ()

    gboolean
    g_action_group_query_action (GActionGroup *action_group,
                                 const gchar *action_name,
                                 gboolean *enabled,
                                 const GVariantType **parameter_type,
                                 const GVariantType **state_type,
                                 GVariant **state_hint,
                                 GVariant **state);

Queries all aspects of the named action within an `action_group` .

This function acquires the information available from `g_action_group_has_action()`, `g_action_group_get_action_enabled()`, `g_action_group_get_action_parameter_type()`, `g_action_group_get_action_state_type()`, `g_action_group_get_action_state_hint()` and `g_action_group_get_action_state()` with a single function call.

This provides two main benefits.

The first is the improvement in efficiency that comes with not having to perform repeated lookups of the action in order to discover different things about it. The second is that implementing GActionGroup can now be done by only overriding this one virtual function.

The interface provides a default implementation of this function that calls the individual functions, as required, to fetch the information. The interface also provides default implementations of those functions that call this function. All implementations, therefore, must override either this function or all of the others.

If the action exists, `TRUE` is returned and any of the requested fields (as indicated by having a non-`NULL` reference passed in) are filled. If the action doesn't exist, `FALSE` is returned and the fields may or may not have been modified.

#### Parameters

action_group | a GActionGroup |
action_name | the name of an action in the group |
enabled | if the action is presently enabled. | [out]
parameter_type | the parameter type, or `NULL` if none needed. | [out][optional]
state_type | the state type, or `NULL` if stateless. | [out][optional]
state_hint | the state hint, or `NULL` if none. | [out][optional]
state | the current state, or `NULL` if stateless. | [out][optional]

#### Returns

`TRUE` if the action exists, else `FALSE`

Since: 2.32

### g_action_group_has_action ()

    gboolean
    g_action_group_has_action (GActionGroup *action_group,
                               const gchar *action_name);

Checks if the named action exists within `action_group` .

#### Parameters

action_group | a GActionGroup |
action_name | the name of the action to check for |

#### Returns

whether the named action exists

Since: 2.28

### g_action_group_get_action_enabled ()

    gboolean
    g_action_group_get_action_enabled (GActionGroup *action_group,
                                       const gchar *action_name);

Checks if the named action within `action_group` is currently enabled.

An action must be enabled in order to be activated or in order to have its state changed from outside callers.

#### Parameters

action_group | a GActionGroup |
action_name | the name of the action to query |

#### Returns

whether or not the action is currently enabled

Since: 2.28

### g_action_group_get_action_parameter_type ()

    const GVariantType *
    g_action_group_get_action_parameter_type
                                   (GActionGroup *action_group,
                                    const gchar *action_name);

Queries the type of the parameter that must be given when activating the named action within `action_group` .

When activating the action using `g_action_group_activate_action()`, the GVariant given to that function must be of the type returned by this function.

In the case that this function returns `NULL`, you must not give any GVariant, but `NULL` instead.

The parameter type of a particular action will never change but it is possible for an action to be removed and for a new action to be added with the same name but a different parameter type.

#### Parameters

action_group | a GActionGroup |
action_name | the name of the action to query |

#### Returns

the parameter type.

[nullable]

Since: 2.28

### g_action_group_get_action_state_type ()

    const GVariantType *
    g_action_group_get_action_state_type (GActionGroup *action_group,
                                          const gchar *action_name);

Queries the type of the state of the named action within `action_group` .

If the action is stateful then this function returns the GVariantType of the state. All calls to `g_action_group_change_action_state()` must give a GVariant of this type and `g_action_group_get_action_state()` will return a GVariant of the same type.

If the action is not stateful then this function will return `NULL`. In that case, `g_action_group_get_action_state()` will return `NULL` and you must not call `g_action_group_change_action_state()`.

The state type of a particular action will never change but it is possible for an action to be removed and for a new action to be added with the same name but a different state type.

#### Parameters

action_group | a GActionGroup |
action_name | the name of the action to query |

#### Returns

the state type, if the action is stateful.

[nullable]

Since: 2.28

### g_action_group_get_action_state_hint ()

    GVariant *
    g_action_group_get_action_state_hint (GActionGroup *action_group,
                                          const gchar *action_name);

Requests a hint about the valid range of values for the state of the named action within `action_group` .

If `NULL` is returned it either means that the action is not stateful or that there is no hint about the valid range of values for the state of the action.

If a GVariant array is returned then each item in the array is a possible value for the state. If a GVariant pair (ie: two-tuple) is returned then the tuple specifies the inclusive lower and upper bound of valid values for the state.

In any case, the information is merely a hint. It may be possible to have a state value outside of the hinted range and setting a value within the range may fail.

The return value (if non-`NULL`) should be freed with `g_variant_unref()` when it is no longer required.

#### Parameters

action_group | a GActionGroup |
action_name | the name of the action to query |

#### Returns

the state range hint.

[nullable][transfer full]

Since: 2.28

### g_action_group_get_action_state ()

    GVariant *
    g_action_group_get_action_state (GActionGroup *action_group,
                                     const gchar *action_name);

Queries the current state of the named action within `action_group` .

If the action is not stateful then `NULL` will be returned. If the action is stateful then the type of the return value is the type given by `g_action_group_get_action_state_type()`.

The return value (if non-`NULL`) should be freed with `g_variant_unref()` when it is no longer required.

#### Parameters

action_group | a GActionGroup |
action_name | the name of the action to query |

#### Returns

the current state of the action.

[nullable]

Since: 2.28

### g_action_group_change_action_state ()

    void
    g_action_group_change_action_state (GActionGroup *action_group,
                                        const gchar *action_name,
                                        GVariant *value);

Request for the state of the named action within `action_group` to be changed to `value` .

The action must be stateful and `value` must be of the correct type. See `g_action_group_get_action_state_type()`.

This call merely requests a change. The action may refuse to change its state or may change its state to something other than `value` . See `g_action_group_get_action_state_hint()`.

If the `value` GVariant is floating, it is consumed.

#### Parameters

action_group | a GActionGroup |
action_name | the name of the action to request the change on |
value | the new state |

Since: 2.28

### g_action_group_activate_action ()

    void
    g_action_group_activate_action (GActionGroup *action_group,
                                    const gchar *action_name,
                                    GVariant *parameter);

Activate the named action within `action_group` .

If the action is expecting a parameter, then the correct type of parameter must be given as `parameter` . If the action is expecting no parameters then `parameter` must be `NULL`. See `g_action_group_get_action_parameter_type()`.

#### Parameters

action_group | a GActionGroup |
action_name | the name of the action to activate |
parameter | parameters to the activation. | [nullable]

Since: 2.28

### g_action_group_action_added ()

    void
    g_action_group_action_added (GActionGroup *action_group,
                                 const gchar *action_name);

Emits the “action-added” signal on `action_group` .

This function should only be called by GActionGroup implementations.

#### Parameters

action_group | a GActionGroup |
action_name | the name of an action in the group |

Since: 2.28

### g_action_group_action_removed ()

    void
    g_action_group_action_removed (GActionGroup *action_group,
                                   const gchar *action_name);

Emits the “action-removed” signal on `action_group` .

This function should only be called by GActionGroup implementations.

#### Parameters

action_group | a GActionGroup |
action_name | the name of an action in the group |

Since: 2.28

### g_action_group_action_enabled_changed ()

    void
    g_action_group_action_enabled_changed (GActionGroup *action_group,
                                           const gchar *action_name,
                                           gboolean enabled);

Emits the “action-enabled-changed” signal on `action_group` .

This function should only be called by GActionGroup implementations.

#### Parameters

action_group | a GActionGroup |
action_name | the name of an action in the group |
enabled | whether or not the action is now enabled |

Since: 2.28

### g_action_group_action_state_changed ()

    void
    g_action_group_action_state_changed (GActionGroup *action_group,
                                         const gchar *action_name,
                                         GVariant *state);

Emits the “action-state-changed” signal on `action_group` .

This function should only be called by GActionGroup implementations.

#### Parameters

action_group | a GActionGroup |
action_name | the name of an action in the group |
state | the new state of the named action |

Since: 2.28

## Types and Values

### GActionGroup

    typedef struct _GActionGroup GActionGroup;

GActionGroup is an opaque data structure and can only be accessed using the following functions.

### struct GActionGroupInterface

    struct GActionGroupInterface {
      GTypeInterface g_iface;

      /* virtual functions */
      gboolean              (* has_action)                 (GActionGroup  *action_group,
                                                            const gchar   *action_name);

      gchar **              (* list_actions)               (GActionGroup  *action_group);

      gboolean              (* get_action_enabled)         (GActionGroup  *action_group,
                                                            const gchar   *action_name);

      const GVariantType *  (* get_action_parameter_type)  (GActionGroup  *action_group,
                                                            const gchar   *action_name);

      const GVariantType *  (* get_action_state_type)      (GActionGroup  *action_group,
                                                            const gchar   *action_name);

      GVariant *            (* get_action_state_hint)      (GActionGroup  *action_group,
                                                            const gchar   *action_name);

      GVariant *            (* get_action_state)           (GActionGroup  *action_group,
                                                            const gchar   *action_name);

      void                  (* change_action_state)        (GActionGroup  *action_group,
                                                            const gchar   *action_name,
                                                            GVariant      *value);

      void                  (* activate_action)            (GActionGroup  *action_group,
                                                            const gchar   *action_name,
                                                            GVariant      *parameter);

      /* signals */
      void                  (* action_added)               (GActionGroup  *action_group,
                                                            const gchar   *action_name);
      void                  (* action_removed)             (GActionGroup  *action_group,
                                                            const gchar   *action_name);
      void                  (* action_enabled_changed)     (GActionGroup  *action_group,
                                                            const gchar   *action_name,
                                                            gboolean       enabled);
      void                  (* action_state_changed)       (GActionGroup   *action_group,
                                                            const gchar    *action_name,
                                                            GVariant       *state);

      /* more virtual functions */
      gboolean              (* query_action)               (GActionGroup        *action_group,
                                                            const gchar         *action_name,
                                                            gboolean            *enabled,
                                                            const GVariantType **parameter_type,
                                                            const GVariantType **state_type,
                                                            GVariant           **state_hint,
                                                            GVariant           **state);
    };

The virtual function table for GActionGroup.

#### Members

`has_action` () | the virtual function pointer for `g_action_group_has_action()` |
`list_actions` () | the virtual function pointer for `g_action_group_list_actions()` |
`get_action_enabled` () | the virtual function pointer for `g_action_group_get_action_enabled()` |
`get_action_parameter_type` () | the virtual function pointer for `g_action_group_get_action_parameter_type()` |
`get_action_state_type` () | the virtual function pointer for `g_action_group_get_action_state_type()` |
`get_action_state_hint` () | the virtual function pointer for `g_action_group_get_action_state_hint()` |
`get_action_state` () | the virtual function pointer for `g_action_group_get_action_state()` |
`change_action_state` () | the virtual function pointer for `g_action_group_change_action_state()` |
`activate_action` () | the virtual function pointer for `g_action_group_activate_action()` |
`action_added` () | the class closure for the “action-added” signal |
`action_removed` () | the class closure for the “action-removed” signal |
`action_enabled_changed` () | the class closure for the “action-enabled-changed” signal |
`action_state_changed` () | the class closure for the “action-enabled-changed” signal |
`query_action` () | the virtual function pointer for `g_action_group_query_action()` |

Since: 2.28

## Signal Details

### The `“action-added”` signal

    void
    user_function (GActionGroup *action_group,
                   gchar        *action_name,
                   gpointer      user_data)

Signals that a new action was just added to the group. This signal is emitted after the action has been added and is now visible.

#### Parameters

action_group | the GActionGroup that changed |
action_name | the name of the action in `action_group` |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

Since: 2.28

### The `“action-enabled-changed”` signal

    void
    user_function (GActionGroup *action_group,
                   gchar        *action_name,
                   gboolean      enabled,
                   gpointer      user_data)

Signals that the enabled status of the named action has changed.

#### Parameters

action_group | the GActionGroup that changed |
action_name | the name of the action in `action_group` |
enabled | whether the action is enabled or not |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

Since: 2.28

### The `“action-removed”` signal

    void
    user_function (GActionGroup *action_group,
                   gchar        *action_name,
                   gpointer      user_data)

Signals that an action is just about to be removed from the group. This signal is emitted before the action is removed, so the action is still visible and can be queried from the signal handler.

#### Parameters

action_group | the GActionGroup that changed |
action_name | the name of the action in `action_group` |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

Since: 2.28

### The `“action-state-changed”` signal

    void
    user_function (GActionGroup *action_group,
                   gchar        *action_name,
                   GVariant     *value,
                   gpointer      user_data)

Signals that the state of the named action has changed.

#### Parameters

action_group | the GActionGroup that changed |
action_name | the name of the action in `action_group` |
value | the new value of the state |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

Since: 2.28

## See Also

GAction